#!/bin/dash
#
# Enable and tweak Compiz by default if compositing is functioning properly
# -Fewt
#

COMPOSITING="$(compiz-check >/dev/null 2>&1 && echo OK)"

if [ ! -d "$HOME/.config/cairo-dock/current_theme" ]; then
  mkdir -p $HOME/.config/cairo-dock
  cp -rf /usr/share/cairo-dock/themes/_default_ $HOME/.config/cairo-dock/current_theme
  chown -R $USER:$USER $HOME/.config/cairo-dock
  chmod -R 775 $HOME/.config/cairo-dock
fi


if [ "$COMPOSITING" = "OK" ]; then
  gconftool-2 -t string -s /desktop/gnome/session/required_components/windowmanager "compiz-gtk"
  gconftool-2 -t bool -s /apps/metacity/general/compositing_manager 1
  nohup compiz-gtk --replace >/dev/null 2>&1 &
  gconftool-2 -t bool -s /apps/compiz/general/screen0/options/sync_to_vblank "false"
  gconftool-2 -t int -s /apps/compiz/general/screen0/options/refresh_rate "200"
  gconftool-2 -t bool -s /apps/compiz/general/screen0/options/detect_refresh_rate "false"
  gconftool-2 --set -t list --list-type=string /apps/compiz/general/allscreens/options/active_plugins "[core,glib,gconf,gnomecompat,dbus,png,svg,video,screenshot,decoration,clone,place,fade,minimize,wall,move,resize,switcher,scale,obs]"
  #sed -i "s#fake transparency=true#fake transparency=false#" $HOME/.config/cairo-dock/current_theme/cairo-dock.conf
else
  gconftool-2 -t string -s /desktop/gnome/session/required_components/windowmanager "metacity"
  gconftool-2 -t bool -s /apps/metacity/general/compositing_manager 1
  nohup metacity --replace >/dev/null 2>&1 &
  #sed -i "s#fake transparency=false#fake transparency=true#" $HOME/.config/cairo-dock/current_theme/cairo-dock.conf
fi

sleep 3;
if [ ! -e "/home/$USER/.config/autostart/compiz-runonce.desktop" ]; then
  cp /etc/xdg/autostart/compiz-runonce.desktop /home/$USER/.config/autostart/compiz-runonce.desktop
  chmod 755 /home/$USER/.config/autostart/compiz-runonce.desktop
  echo "X-GNOME-Autostart-enabled=false" >> /home/$USER/.config/autostart/compiz-runonce.desktop
fi

cairo-runonce.sh DOCK
